//+------------------------------------------------------------------+
//|                                        TREND TRADER BY AUTHE.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http: //www.metaquotes.net"
#property show_inputs
//-------------------------------------------------------------------
extern int P = 20, TakeProfit =50, Max=30, Slippage = 30,  Margin = 100;
extern double Lots = 0.1;
datetime time0 = 0;
//-------------------------------------------------------------------
bool UseSound      = True;              //   
string NameFileSound = "expert.wav";    //   
color clOpenBuy     = LightBlue;        //   BuyStop
color clOpenSell    = LightCoral;       //   SellStop
string Name_Expert   = "Set2StopOrders";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
	//----

	//----
	return (0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
	//----

	//----
	return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start()
{
	bool hangingman = Hanging_man(), hammer = Hammer(), uptrend = Uptrend(), downtrend = Downtrend();
	int Free = AccountFreeMargin();
	double ldStop=0, ldTake=0;
  double pAsk=High[1]+20*Point;
  double pBid=Low[1]-20*Point;
  double StopLoss=High[1]-Low[1];
  //---------------------------------------------------------------------------------------------
   if(Free<Margin){return;}
  //---------------------------------------------------------------------------------------------   
	if (time0 != Time[0]) {
		//-------------------------------------------------------------------
		while (true) {
			
			//--------------------------------------
			
				if (hangingman != true && uptrend != true)
					break;else
				if (StopLoss!=0) ldStop=pBid+StopLoss*Point;
  if (TakeProfit!=0) ldTake=pBid-TakeProfit*Point;
  int Ticket=SetOrder(OP_SELLSTOP, pBid, ldStop, ldTake);
  				if (Ticket < 0)
					time0 =0 ;
					else
				time0=Time[0];
			}
			//--------------------------------------
			while (true) {
				if (hammer != true && downtrend != true )
					break;else
				if (StopLoss!=0) ldStop=pAsk-StopLoss*Point;
  if (TakeProfit!=0) ldTake=pAsk+TakeProfit*Point;
  int Ticket1=SetOrder(OP_BUYSTOP, pAsk, ldStop, ldTake);
				if (Ticket1 < 0)
					time0=0;
					else
					time0=Time[0];
						}Alert (GetLastError());
		}
	
	//----

	//----
	return (0);
}


//+-----------------------------------------------------------------------------+
//+----------USER DEFINE--------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
int SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  string lsComm=GetCommentForOrder();
  double D=(High[1]-Low[1])/Point;
//-------------------------------------------------------------
  if (D>30)
  return(-1);
//--------------------------------------------------------------
  if (op==OP_BUYSTOP) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
 int Ticket=OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,0,0,clOpen);
//------------------------------------------------------------------------  
  if (UseSound) PlaySound(NameFileSound);
//------------------------------------------------------------------------
  if(Ticket>0)
  return(Ticket);else
  return(-1);   
  
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert+" "+GetNameTF(Period()));
}

//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
	switch (TimeFrame) {
		case PERIOD_MN1: return("Monthly");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_D1:  return("Daily");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
}
//+------------------------------------------------------------------+


//+-------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------+
bool Hanging_man()
{
	double H = High[1], L = Low[1], O = Open[1], C = Close[1];

	if (((H - O) / (O - C) >= 2.0 && (O - C) / (C - L) >= 0.5) || ( ((H - O) / (O - C)) >= 2.5 && (C - L) == 0))
	{ return (true); } else {
		if (((H - C) / (C - O) >= 2.0 && (C - O) / (O - L) >= 0.5) || ( ((H - C) / (C - O)) >= 2.5 && (O - L) == 0))
		{ return (true); }
	}
	return (false);
}
//+--------------------------------------------------------------------------------+
//+--------------------------------------------------------------------------------+
bool Hammer()
{
	double H = High[1], L = Low[1], O = Open[1], C = Close[1];
	if ((((C - L) / (O - C)) >= 2.0 && (O - C) / (H - O) >= 0.5)  || ( ((C - L) / (O - C)) >= 2.5 && (H - O) == 0))
	{ return (true); } else
	{ if (((O - L) / (C - O) >= 2.0 && (C - O) / (H - C) >= 0.5) || ( ((O - L) / (C - O)) >= 2.5 && (H - C) == 0))
	  { return (true); } }
	return (false);
}
//+-----------------------------------------------------------------------------------+
//+-----------------------------------------------------------------------------------+
bool Uptrend() {
	if (( High[2] > High[3] ) || ( Low[2] > Low[3] )) return (true);return (false);
}
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+
bool Downtrend() {
	if (( High[2] < High[3] ) || ( Low[2] < Low[3] ))
		return (true);
	return (false);
}
//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+


//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+

//+------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------+

